#include <clutter/clutter.h>

int
main (int argc, char **argv)
{
  gfloat width, height;
  ClutterAnimation *animation;
  ClutterVertex rotation_center;
  ClutterActor *stage, *background, *actor;

  /* Initialise clutter */
  clutter_init (&argc, &argv);

  /* Create a fullscreen stage */
  stage = clutter_stage_get_default ();
  clutter_stage_set_fullscreen (CLUTTER_STAGE (stage), TRUE);
  clutter_actor_get_size (stage, &width, &height);

  /* Add a backgroud at the size of the stage */
  background = clutter_texture_new_from_file ("images/background.jpg", NULL);
  clutter_actor_set_size (background, width, height);
  clutter_container_add_actor (CLUTTER_CONTAINER (stage), background);

  /* Add an actor */
  actor = clutter_texture_new_from_file ("images/actor.png", NULL);
  clutter_actor_set_size (actor, width/5, height/5);
  clutter_actor_set_position (actor, width/2 - width/10, height/2 - height/10);
  clutter_container_add_actor (CLUTTER_CONTAINER (stage), actor);

  /* Do a basic rotation animation */
  rotation_center = (ClutterVertex){ width/10, height/10, 0 };
  animation =
    clutter_actor_animate (actor, CLUTTER_LINEAR, 1000,
                           "rotation-angle-z", 360.f,
                           "fixed::rotation-center-z", &rotation_center,
                           NULL);
  clutter_animation_set_loop (animation, TRUE);

  /* Close when we press a key */
  g_signal_connect (stage, "key-press-event",
                    G_CALLBACK (clutter_main_quit), NULL);

  /* Startup the application */
  clutter_actor_show (stage);
  clutter_main ();

  return 0;
}

