#include <clutter/clutter.h>

static gboolean
button_press_cb (ClutterActor       *stage,
                 ClutterButtonEvent *event,
                 ClutterActor       *actor)
{
  /* Move the actor to where we clicked */
  clutter_actor_animate (actor, CLUTTER_EASE_OUT_QUAD, 1000,
                         "x", (gfloat)event->x,
                         "y", (gfloat)event->y,
                         NULL);
  return TRUE;
}

int
main (int argc, char **argv)
{
  gfloat width, height;
  ClutterActor *stage, *background, *actor;

  /* Initialise clutter */
  clutter_init (&argc, &argv);

  /* Create a fullscreen stage */
  stage = clutter_stage_get_default ();
  clutter_stage_set_fullscreen (CLUTTER_STAGE (stage), TRUE);
  clutter_actor_get_size (stage, &width, &height);

  /* Add a backgroud at the size of the stage */
  background = clutter_texture_new_from_file ("images/background.jpg", NULL);
  clutter_actor_set_size (background, width, height);
  clutter_container_add_actor (CLUTTER_CONTAINER (stage), background);

  /* Add an actor */
  actor = clutter_texture_new_from_file ("images/actor.png", NULL);
  clutter_actor_set_size (actor, width/5, height/5);
  clutter_container_add_actor (CLUTTER_CONTAINER (stage), actor);

  /* Respond to clicking on the stage */
  g_signal_connect (stage, "button-press-event",
                    G_CALLBACK (button_press_cb), actor);

  /* Close when we press a key */
  g_signal_connect (stage, "key-press-event",
                    G_CALLBACK (clutter_main_quit), NULL);

  /* Startup the application */
  clutter_actor_show (stage);
  clutter_main ();

  return 0;
}

